// ------------------------------------------------------------------------- 
// High Level Design Compiler for Intel(R) FPGAs Version 20.3 (Release Build #121)
// 
// Legal Notice: Copyright 2020 Intel Corporation.  All rights reserved.
// Your use of  Intel Corporation's design tools,  logic functions and other
// software and  tools, and its AMPP partner logic functions, and any output
// files any  of the foregoing (including  device programming  or simulation
// files), and  any associated  documentation  or information  are expressly
// subject  to the terms and  conditions of the  Intel FPGA Software License
// Agreement, Intel MegaCore Function License Agreement, or other applicable
// license agreement,  including,  without limitation,  that your use is for
// the  sole  purpose of  programming  logic devices  manufactured by  Intel
// and  sold by Intel  or its authorized  distributors. Please refer  to the
// applicable agreement for further details.
// ---------------------------------------------------------------------------

// SystemVerilog created from k2_ZTS6c_calc_ZTS6c_calc_B0_branch
// SystemVerilog created on Thu Nov  5 06:32:57 2020


(* altera_attribute = "-name AUTO_SHIFT_REGISTER_RECOGNITION OFF; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 10037; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 15400; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 12020; -name MESSAGE_DISABLE 12030; -name MESSAGE_DISABLE 12010; -name MESSAGE_DISABLE 12110; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 13410; -name MESSAGE_DISABLE 113007; -name MESSAGE_DISABLE 10958" *)
module k2_ZTS6c_calc_ZTS6c_calc_B0_branch (
    input wire [63:0] in_acl_global_id_0,
    input wire [63:0] in_acl_global_id_1,
    input wire [31:0] in_acl_group_id_1,
    input wire [31:0] in_acl_hw_wg_id,
    input wire [31:0] in_c0_exe1,
    input wire [31:0] in_c0_exe2,
    input wire [0:0] in_c0_exe3,
    input wire [31:0] in_c0_exe4,
    input wire [63:0] in_c0_exe5,
    input wire [63:0] in_c0_exe6,
    input wire [63:0] in_c0_exe7,
    input wire [63:0] in_c0_exe8,
    input wire [31:0] in_l_grpid_0,
    input wire [0:0] in_stall_in_0,
    input wire [0:0] in_stall_in_1,
    input wire [0:0] in_valid_in,
    output wire [63:0] out_acl_global_id_0,
    output wire [63:0] out_acl_global_id_1,
    output wire [31:0] out_acl_group_id_1,
    output wire [31:0] out_acl_hw_wg_id,
    output wire [31:0] out_c0_exe1,
    output wire [31:0] out_c0_exe2,
    output wire [31:0] out_c0_exe4,
    output wire [63:0] out_c0_exe5,
    output wire [63:0] out_c0_exe6,
    output wire [63:0] out_c0_exe7,
    output wire [63:0] out_c0_exe8,
    output wire [31:0] out_l_grpid_0,
    output wire [0:0] out_stall_out,
    output wire [0:0] out_valid_out_0,
    output wire [0:0] out_valid_out_1,
    input wire clock,
    input wire resetn
    );

    wire [0:0] VCC_q;
    wire [0:0] ZTS6c_calc_B0_branch_enable_q;
    wire [0:0] ZTS6c_calc_B0_branch_enable_not_q;
    reg [63:0] acl_global_id_0_reg_q;
    reg [63:0] acl_global_id_1_reg_q;
    reg [31:0] acl_group_id_1_reg_q;
    reg [31:0] acl_hw_wg_id_reg_q;
    reg [31:0] c0_exe1_reg_q;
    reg [31:0] c0_exe2_reg_q;
    wire [0:0] c0_exe3_cmp_q;
    reg [31:0] c0_exe4_reg_q;
    reg [63:0] c0_exe5_reg_q;
    reg [63:0] c0_exe6_reg_q;
    reg [63:0] c0_exe7_reg_q;
    reg [63:0] c0_exe8_reg_q;
    reg [31:0] l_grpid_0_reg_q;
    wire [0:0] not_stall_in_0_q;
    wire [0:0] not_stall_in_1_q;
    wire [0:0] not_valid_0_q;
    wire [0:0] not_valid_1_q;
    wire [0:0] not_valid_or_not_stall_0_q;
    wire [0:0] not_valid_or_not_stall_1_q;
    reg [0:0] valid_0_reg_q;
    reg [0:0] valid_1_reg_q;
    wire [0:0] valid_out_0_and_q;
    wire [0:0] valid_out_1_and_q;


    // VCC(CONSTANT,1)
    assign VCC_q = $unsigned(1'b1);

    // not_stall_in_1(LOGICAL,34)
    assign not_stall_in_1_q = ~ (in_stall_in_1);

    // c0_exe3_cmp(LOGICAL,10)
    assign c0_exe3_cmp_q = ~ (in_c0_exe3);

    // valid_out_1_and(LOGICAL,57)
    assign valid_out_1_and_q = in_valid_in & c0_exe3_cmp_q;

    // valid_1_reg(REG,55)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            valid_1_reg_q <= $unsigned(1'b0);
        end
        else if (ZTS6c_calc_B0_branch_enable_q == 1'b1)
        begin
            valid_1_reg_q <= valid_out_1_and_q;
        end
    end

    // not_valid_1(LOGICAL,36)
    assign not_valid_1_q = ~ (valid_1_reg_q);

    // not_valid_or_not_stall_1(LOGICAL,38)
    assign not_valid_or_not_stall_1_q = not_valid_1_q | not_stall_in_1_q;

    // not_stall_in_0(LOGICAL,33)
    assign not_stall_in_0_q = ~ (in_stall_in_0);

    // valid_out_0_and(LOGICAL,56)
    assign valid_out_0_and_q = in_valid_in & in_c0_exe3;

    // valid_0_reg(REG,54)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            valid_0_reg_q <= $unsigned(1'b0);
        end
        else if (ZTS6c_calc_B0_branch_enable_q == 1'b1)
        begin
            valid_0_reg_q <= valid_out_0_and_q;
        end
    end

    // not_valid_0(LOGICAL,35)
    assign not_valid_0_q = ~ (valid_0_reg_q);

    // not_valid_or_not_stall_0(LOGICAL,37)
    assign not_valid_or_not_stall_0_q = not_valid_0_q | not_stall_in_0_q;

    // ZTS6c_calc_B0_branch_enable(LOGICAL,2)
    assign ZTS6c_calc_B0_branch_enable_q = not_valid_or_not_stall_0_q & not_valid_or_not_stall_1_q;

    // acl_global_id_0_reg(REG,4)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            acl_global_id_0_reg_q <= $unsigned(64'b0000000000000000000000000000000000000000000000000000000000000000);
        end
        else if (ZTS6c_calc_B0_branch_enable_q == 1'b1)
        begin
            acl_global_id_0_reg_q <= in_acl_global_id_0;
        end
    end

    // out_acl_global_id_0(GPOUT,39)
    assign out_acl_global_id_0 = acl_global_id_0_reg_q;

    // acl_global_id_1_reg(REG,5)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            acl_global_id_1_reg_q <= $unsigned(64'b0000000000000000000000000000000000000000000000000000000000000000);
        end
        else if (ZTS6c_calc_B0_branch_enable_q == 1'b1)
        begin
            acl_global_id_1_reg_q <= in_acl_global_id_1;
        end
    end

    // out_acl_global_id_1(GPOUT,40)
    assign out_acl_global_id_1 = acl_global_id_1_reg_q;

    // acl_group_id_1_reg(REG,6)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            acl_group_id_1_reg_q <= $unsigned(32'b00000000000000000000000000000000);
        end
        else if (ZTS6c_calc_B0_branch_enable_q == 1'b1)
        begin
            acl_group_id_1_reg_q <= in_acl_group_id_1;
        end
    end

    // out_acl_group_id_1(GPOUT,41)
    assign out_acl_group_id_1 = acl_group_id_1_reg_q;

    // acl_hw_wg_id_reg(REG,7)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            acl_hw_wg_id_reg_q <= $unsigned(32'b00000000000000000000000000000000);
        end
        else if (ZTS6c_calc_B0_branch_enable_q == 1'b1)
        begin
            acl_hw_wg_id_reg_q <= in_acl_hw_wg_id;
        end
    end

    // out_acl_hw_wg_id(GPOUT,42)
    assign out_acl_hw_wg_id = acl_hw_wg_id_reg_q;

    // c0_exe1_reg(REG,8)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            c0_exe1_reg_q <= $unsigned(32'b00000000000000000000000000000000);
        end
        else if (ZTS6c_calc_B0_branch_enable_q == 1'b1)
        begin
            c0_exe1_reg_q <= in_c0_exe1;
        end
    end

    // out_c0_exe1(GPOUT,43)
    assign out_c0_exe1 = c0_exe1_reg_q;

    // c0_exe2_reg(REG,9)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            c0_exe2_reg_q <= $unsigned(32'b00000000000000000000000000000000);
        end
        else if (ZTS6c_calc_B0_branch_enable_q == 1'b1)
        begin
            c0_exe2_reg_q <= in_c0_exe2;
        end
    end

    // out_c0_exe2(GPOUT,44)
    assign out_c0_exe2 = c0_exe2_reg_q;

    // c0_exe4_reg(REG,11)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            c0_exe4_reg_q <= $unsigned(32'b00000000000000000000000000000000);
        end
        else if (ZTS6c_calc_B0_branch_enable_q == 1'b1)
        begin
            c0_exe4_reg_q <= in_c0_exe4;
        end
    end

    // out_c0_exe4(GPOUT,45)
    assign out_c0_exe4 = c0_exe4_reg_q;

    // c0_exe5_reg(REG,12)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            c0_exe5_reg_q <= $unsigned(64'b0000000000000000000000000000000000000000000000000000000000000000);
        end
        else if (ZTS6c_calc_B0_branch_enable_q == 1'b1)
        begin
            c0_exe5_reg_q <= in_c0_exe5;
        end
    end

    // out_c0_exe5(GPOUT,46)
    assign out_c0_exe5 = c0_exe5_reg_q;

    // c0_exe6_reg(REG,13)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            c0_exe6_reg_q <= $unsigned(64'b0000000000000000000000000000000000000000000000000000000000000000);
        end
        else if (ZTS6c_calc_B0_branch_enable_q == 1'b1)
        begin
            c0_exe6_reg_q <= in_c0_exe6;
        end
    end

    // out_c0_exe6(GPOUT,47)
    assign out_c0_exe6 = c0_exe6_reg_q;

    // c0_exe7_reg(REG,14)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            c0_exe7_reg_q <= $unsigned(64'b0000000000000000000000000000000000000000000000000000000000000000);
        end
        else if (ZTS6c_calc_B0_branch_enable_q == 1'b1)
        begin
            c0_exe7_reg_q <= in_c0_exe7;
        end
    end

    // out_c0_exe7(GPOUT,48)
    assign out_c0_exe7 = c0_exe7_reg_q;

    // c0_exe8_reg(REG,15)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            c0_exe8_reg_q <= $unsigned(64'b0000000000000000000000000000000000000000000000000000000000000000);
        end
        else if (ZTS6c_calc_B0_branch_enable_q == 1'b1)
        begin
            c0_exe8_reg_q <= in_c0_exe8;
        end
    end

    // out_c0_exe8(GPOUT,49)
    assign out_c0_exe8 = c0_exe8_reg_q;

    // l_grpid_0_reg(REG,32)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            l_grpid_0_reg_q <= $unsigned(32'b00000000000000000000000000000000);
        end
        else if (ZTS6c_calc_B0_branch_enable_q == 1'b1)
        begin
            l_grpid_0_reg_q <= in_l_grpid_0;
        end
    end

    // out_l_grpid_0(GPOUT,50)
    assign out_l_grpid_0 = l_grpid_0_reg_q;

    // ZTS6c_calc_B0_branch_enable_not(LOGICAL,3)
    assign ZTS6c_calc_B0_branch_enable_not_q = ~ (ZTS6c_calc_B0_branch_enable_q);

    // out_stall_out(GPOUT,51)
    assign out_stall_out = ZTS6c_calc_B0_branch_enable_not_q;

    // out_valid_out_0(GPOUT,52)
    assign out_valid_out_0 = valid_0_reg_q;

    // out_valid_out_1(GPOUT,53)
    assign out_valid_out_1 = valid_1_reg_q;

endmodule
