// ------------------------------------------------------------------------- 
// High Level Design Compiler for Intel(R) FPGAs Version 20.3 (Release Build #121)
// 
// Legal Notice: Copyright 2020 Intel Corporation.  All rights reserved.
// Your use of  Intel Corporation's design tools,  logic functions and other
// software and  tools, and its AMPP partner logic functions, and any output
// files any  of the foregoing (including  device programming  or simulation
// files), and  any associated  documentation  or information  are expressly
// subject  to the terms and  conditions of the  Intel FPGA Software License
// Agreement, Intel MegaCore Function License Agreement, or other applicable
// license agreement,  including,  without limitation,  that your use is for
// the  sole  purpose of  programming  logic devices  manufactured by  Intel
// and  sold by Intel  or its authorized  distributors. Please refer  to the
// applicable agreement for further details.
// ---------------------------------------------------------------------------

// SystemVerilog created from k2_ZTS6c_calc_ZTS6c_calc_B6_branch
// SystemVerilog created on Thu Nov  5 06:32:57 2020


(* altera_attribute = "-name AUTO_SHIFT_REGISTER_RECOGNITION OFF; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 10037; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 15400; -name MESSAGE_DISABLE 14130; -name MESSAGE_DISABLE 10036; -name MESSAGE_DISABLE 12020; -name MESSAGE_DISABLE 12030; -name MESSAGE_DISABLE 12010; -name MESSAGE_DISABLE 12110; -name MESSAGE_DISABLE 14320; -name MESSAGE_DISABLE 13410; -name MESSAGE_DISABLE 113007; -name MESSAGE_DISABLE 10958" *)
module k2_ZTS6c_calc_ZTS6c_calc_B6_branch (
    input wire [31:0] in_acl_0141_i50933,
    input wire [31:0] in_acl_0142_i50835,
    input wire [63:0] in_acl_global_id_042,
    input wire [63:0] in_acl_global_id_148,
    input wire [31:0] in_acl_hw_wg_id55,
    input wire [31:0] in_c0_exe154,
    input wire [31:0] in_c0_exe255,
    input wire [31:0] in_c0_exe29,
    input wire [0:0] in_c0_exe356,
    input wire [31:0] in_c0_exe414,
    input wire [63:0] in_c0_exe516,
    input wire [63:0] in_c0_exe622,
    input wire [63:0] in_c0_exe724,
    input wire [63:0] in_c0_exe830,
    input wire [31:0] in_l_grpid_04,
    input wire [63:0] in_l_grpid_0_ext_offset36,
    input wire [0:0] in_stall_in_0,
    input wire [0:0] in_stall_in_1,
    input wire [0:0] in_valid_in,
    output wire [31:0] out_acl_0141_i50933,
    output wire [31:0] out_acl_0142_i50835,
    output wire [63:0] out_acl_global_id_042,
    output wire [63:0] out_acl_global_id_148,
    output wire [31:0] out_acl_hw_wg_id55,
    output wire [31:0] out_c0_exe154,
    output wire [31:0] out_c0_exe255,
    output wire [31:0] out_c0_exe29,
    output wire [31:0] out_c0_exe414,
    output wire [63:0] out_c0_exe516,
    output wire [63:0] out_c0_exe622,
    output wire [63:0] out_c0_exe724,
    output wire [63:0] out_c0_exe830,
    output wire [31:0] out_l_grpid_04,
    output wire [63:0] out_l_grpid_0_ext_offset36,
    output wire [0:0] out_stall_out,
    output wire [0:0] out_valid_out_0,
    output wire [0:0] out_valid_out_1,
    input wire clock,
    input wire resetn
    );

    wire [0:0] VCC_q;
    wire [0:0] ZTS6c_calc_B6_branch_enable_q;
    wire [0:0] ZTS6c_calc_B6_branch_enable_not_q;
    reg [31:0] acl_0141_i50933_reg_q;
    reg [31:0] acl_0142_i50835_reg_q;
    reg [63:0] acl_global_id_042_reg_q;
    reg [63:0] acl_global_id_148_reg_q;
    reg [31:0] acl_hw_wg_id55_reg_q;
    reg [31:0] c0_exe154_reg_q;
    reg [31:0] c0_exe255_reg_q;
    reg [31:0] c0_exe29_reg_q;
    wire [0:0] c0_exe356_cmp_q;
    reg [31:0] c0_exe414_reg_q;
    reg [63:0] c0_exe516_reg_q;
    reg [63:0] c0_exe622_reg_q;
    reg [63:0] c0_exe724_reg_q;
    reg [63:0] c0_exe830_reg_q;
    reg [31:0] l_grpid_04_reg_q;
    reg [63:0] l_grpid_0_ext_offset36_reg_q;
    wire [0:0] not_stall_in_0_q;
    wire [0:0] not_stall_in_1_q;
    wire [0:0] not_valid_0_q;
    wire [0:0] not_valid_1_q;
    wire [0:0] not_valid_or_not_stall_0_q;
    wire [0:0] not_valid_or_not_stall_1_q;
    reg [0:0] valid_0_reg_q;
    reg [0:0] valid_1_reg_q;
    wire [0:0] valid_out_0_and_q;
    wire [0:0] valid_out_1_and_q;


    // VCC(CONSTANT,1)
    assign VCC_q = $unsigned(1'b1);

    // not_stall_in_1(LOGICAL,40)
    assign not_stall_in_1_q = ~ (in_stall_in_1);

    // c0_exe356_cmp(LOGICAL,12)
    assign c0_exe356_cmp_q = ~ (in_c0_exe356);

    // valid_out_1_and(LOGICAL,66)
    assign valid_out_1_and_q = in_valid_in & c0_exe356_cmp_q;

    // valid_1_reg(REG,64)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            valid_1_reg_q <= $unsigned(1'b0);
        end
        else if (ZTS6c_calc_B6_branch_enable_q == 1'b1)
        begin
            valid_1_reg_q <= valid_out_1_and_q;
        end
    end

    // not_valid_1(LOGICAL,42)
    assign not_valid_1_q = ~ (valid_1_reg_q);

    // not_valid_or_not_stall_1(LOGICAL,44)
    assign not_valid_or_not_stall_1_q = not_valid_1_q | not_stall_in_1_q;

    // not_stall_in_0(LOGICAL,39)
    assign not_stall_in_0_q = ~ (in_stall_in_0);

    // valid_out_0_and(LOGICAL,65)
    assign valid_out_0_and_q = in_valid_in & in_c0_exe356;

    // valid_0_reg(REG,63)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            valid_0_reg_q <= $unsigned(1'b0);
        end
        else if (ZTS6c_calc_B6_branch_enable_q == 1'b1)
        begin
            valid_0_reg_q <= valid_out_0_and_q;
        end
    end

    // not_valid_0(LOGICAL,41)
    assign not_valid_0_q = ~ (valid_0_reg_q);

    // not_valid_or_not_stall_0(LOGICAL,43)
    assign not_valid_or_not_stall_0_q = not_valid_0_q | not_stall_in_0_q;

    // ZTS6c_calc_B6_branch_enable(LOGICAL,2)
    assign ZTS6c_calc_B6_branch_enable_q = not_valid_or_not_stall_0_q & not_valid_or_not_stall_1_q;

    // acl_0141_i50933_reg(REG,4)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            acl_0141_i50933_reg_q <= $unsigned(32'b00000000000000000000000000000000);
        end
        else if (ZTS6c_calc_B6_branch_enable_q == 1'b1)
        begin
            acl_0141_i50933_reg_q <= in_acl_0141_i50933;
        end
    end

    // out_acl_0141_i50933(GPOUT,45)
    assign out_acl_0141_i50933 = acl_0141_i50933_reg_q;

    // acl_0142_i50835_reg(REG,5)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            acl_0142_i50835_reg_q <= $unsigned(32'b00000000000000000000000000000000);
        end
        else if (ZTS6c_calc_B6_branch_enable_q == 1'b1)
        begin
            acl_0142_i50835_reg_q <= in_acl_0142_i50835;
        end
    end

    // out_acl_0142_i50835(GPOUT,46)
    assign out_acl_0142_i50835 = acl_0142_i50835_reg_q;

    // acl_global_id_042_reg(REG,6)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            acl_global_id_042_reg_q <= $unsigned(64'b0000000000000000000000000000000000000000000000000000000000000000);
        end
        else if (ZTS6c_calc_B6_branch_enable_q == 1'b1)
        begin
            acl_global_id_042_reg_q <= in_acl_global_id_042;
        end
    end

    // out_acl_global_id_042(GPOUT,47)
    assign out_acl_global_id_042 = acl_global_id_042_reg_q;

    // acl_global_id_148_reg(REG,7)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            acl_global_id_148_reg_q <= $unsigned(64'b0000000000000000000000000000000000000000000000000000000000000000);
        end
        else if (ZTS6c_calc_B6_branch_enable_q == 1'b1)
        begin
            acl_global_id_148_reg_q <= in_acl_global_id_148;
        end
    end

    // out_acl_global_id_148(GPOUT,48)
    assign out_acl_global_id_148 = acl_global_id_148_reg_q;

    // acl_hw_wg_id55_reg(REG,8)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            acl_hw_wg_id55_reg_q <= $unsigned(32'b00000000000000000000000000000000);
        end
        else if (ZTS6c_calc_B6_branch_enable_q == 1'b1)
        begin
            acl_hw_wg_id55_reg_q <= in_acl_hw_wg_id55;
        end
    end

    // out_acl_hw_wg_id55(GPOUT,49)
    assign out_acl_hw_wg_id55 = acl_hw_wg_id55_reg_q;

    // c0_exe154_reg(REG,9)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            c0_exe154_reg_q <= $unsigned(32'b00000000000000000000000000000000);
        end
        else if (ZTS6c_calc_B6_branch_enable_q == 1'b1)
        begin
            c0_exe154_reg_q <= $unsigned(in_c0_exe154);
        end
    end

    // out_c0_exe154(GPOUT,50)
    assign out_c0_exe154 = c0_exe154_reg_q;

    // c0_exe255_reg(REG,10)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            c0_exe255_reg_q <= $unsigned(32'b00000000000000000000000000000000);
        end
        else if (ZTS6c_calc_B6_branch_enable_q == 1'b1)
        begin
            c0_exe255_reg_q <= in_c0_exe255;
        end
    end

    // out_c0_exe255(GPOUT,51)
    assign out_c0_exe255 = c0_exe255_reg_q;

    // c0_exe29_reg(REG,11)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            c0_exe29_reg_q <= $unsigned(32'b00000000000000000000000000000000);
        end
        else if (ZTS6c_calc_B6_branch_enable_q == 1'b1)
        begin
            c0_exe29_reg_q <= in_c0_exe29;
        end
    end

    // out_c0_exe29(GPOUT,52)
    assign out_c0_exe29 = c0_exe29_reg_q;

    // c0_exe414_reg(REG,13)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            c0_exe414_reg_q <= $unsigned(32'b00000000000000000000000000000000);
        end
        else if (ZTS6c_calc_B6_branch_enable_q == 1'b1)
        begin
            c0_exe414_reg_q <= in_c0_exe414;
        end
    end

    // out_c0_exe414(GPOUT,53)
    assign out_c0_exe414 = c0_exe414_reg_q;

    // c0_exe516_reg(REG,14)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            c0_exe516_reg_q <= $unsigned(64'b0000000000000000000000000000000000000000000000000000000000000000);
        end
        else if (ZTS6c_calc_B6_branch_enable_q == 1'b1)
        begin
            c0_exe516_reg_q <= in_c0_exe516;
        end
    end

    // out_c0_exe516(GPOUT,54)
    assign out_c0_exe516 = c0_exe516_reg_q;

    // c0_exe622_reg(REG,15)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            c0_exe622_reg_q <= $unsigned(64'b0000000000000000000000000000000000000000000000000000000000000000);
        end
        else if (ZTS6c_calc_B6_branch_enable_q == 1'b1)
        begin
            c0_exe622_reg_q <= in_c0_exe622;
        end
    end

    // out_c0_exe622(GPOUT,55)
    assign out_c0_exe622 = c0_exe622_reg_q;

    // c0_exe724_reg(REG,16)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            c0_exe724_reg_q <= $unsigned(64'b0000000000000000000000000000000000000000000000000000000000000000);
        end
        else if (ZTS6c_calc_B6_branch_enable_q == 1'b1)
        begin
            c0_exe724_reg_q <= in_c0_exe724;
        end
    end

    // out_c0_exe724(GPOUT,56)
    assign out_c0_exe724 = c0_exe724_reg_q;

    // c0_exe830_reg(REG,17)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            c0_exe830_reg_q <= $unsigned(64'b0000000000000000000000000000000000000000000000000000000000000000);
        end
        else if (ZTS6c_calc_B6_branch_enable_q == 1'b1)
        begin
            c0_exe830_reg_q <= in_c0_exe830;
        end
    end

    // out_c0_exe830(GPOUT,57)
    assign out_c0_exe830 = c0_exe830_reg_q;

    // l_grpid_04_reg(REG,37)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            l_grpid_04_reg_q <= $unsigned(32'b00000000000000000000000000000000);
        end
        else if (ZTS6c_calc_B6_branch_enable_q == 1'b1)
        begin
            l_grpid_04_reg_q <= in_l_grpid_04;
        end
    end

    // out_l_grpid_04(GPOUT,58)
    assign out_l_grpid_04 = l_grpid_04_reg_q;

    // l_grpid_0_ext_offset36_reg(REG,38)
    always @ (posedge clock or negedge resetn)
    begin
        if (!resetn)
        begin
            l_grpid_0_ext_offset36_reg_q <= $unsigned(64'b0000000000000000000000000000000000000000000000000000000000000000);
        end
        else if (ZTS6c_calc_B6_branch_enable_q == 1'b1)
        begin
            l_grpid_0_ext_offset36_reg_q <= in_l_grpid_0_ext_offset36;
        end
    end

    // out_l_grpid_0_ext_offset36(GPOUT,59)
    assign out_l_grpid_0_ext_offset36 = l_grpid_0_ext_offset36_reg_q;

    // ZTS6c_calc_B6_branch_enable_not(LOGICAL,3)
    assign ZTS6c_calc_B6_branch_enable_not_q = ~ (ZTS6c_calc_B6_branch_enable_q);

    // out_stall_out(GPOUT,60)
    assign out_stall_out = ZTS6c_calc_B6_branch_enable_not_q;

    // out_valid_out_0(GPOUT,61)
    assign out_valid_out_0 = valid_0_reg_q;

    // out_valid_out_1(GPOUT,62)
    assign out_valid_out_1 = valid_1_reg_q;

endmodule
